/*
 * svgalib.c
 *
 * svgalib interface.
 */

//#include <kos.h>
#include "osd_cpu.h"
#include <stdlib.h>
#include <stdio.h>

//#include <vga.h>
//#include <vgakeyboard.h>
#include "gnukos.h"

#include "fb.h"
#include "input.h"
#include "rc.h"



//struct fb fb;


static int vmode[3] = { 0, 0, 8 };
static int svga_mode;
static int svga_vsync = 1;

rcvar_t vid_exports[] =
{
	RCV_VECTOR("vmode", vmode, 3),
	RCV_INT("vsync", &svga_vsync),
	RCV_INT("svga_mode", &svga_mode),
	RCV_END
};



/* keymap - mappings of the form { scancode, localcode } - from pc/keymap.c */
extern int keymap[][2];

static int mapscancode(int scan)
{
        //int i;
        //for (i = 0; keymap[i][0]; i++)
        //        if (keymap[i][0] == scan)
        //                return keymap[i][1];
	return 0;
}

static void kbhandler(int scan, int state)
{
	event_t ev;
	ev.type = state ? EV_PRESS : EV_RELEASE;
	ev.code = mapscancode(scan);
	ev_postevent(&ev);
}

int *rc_getvec();

static int selectmode()
{
        return 0;
}



void vid_preinit()
{
        //vga_init();
}

#define RGB565(r, g, b) ((r >> 3) << 11)| ((g >> 2) << 5)| ((b >> 3) << 0)

void _vid_init()
{
        int x,y;

	if (!vmode[0] || !vmode[1])
	{
                int scale = rc_getint("scale");
                if (scale < 1) scale = 1;
		vmode[0] = 160 * scale;
		vmode[1] = 144 * scale;
	}

        //vga_setmode(m);
        //mi = vga_getmodeinfo(m);
        fb.w = 160;
        fb.h = 144;
        fb.pelsize = 1;
        fb.pitch = 320;
        //fb.ptr = vga_getgraphmem();
        fb.ptr = malloc(240*320*2);
	fb.enabled = 1;
	fb.dirty = 0;

        fb.indexed = 1;
        fb.cc[0].r = fb.cc[1].r = fb.cc[2].r = 8;
        fb.cc[0].l = fb.cc[1].l = fb.cc[2].l = 0;
        for(y = 0; y < 240; y++)
                for(x = 0; x < 320; x++)
                        fb.ptr[y*320+x] = RGB565(0,0,0);

}


void vid_close()
{
	if (!fb.ptr) return;
	memset(&fb, 0, sizeof fb);
}

void vid_settitle(char *title)
{
}

int xpal[256];

void vid_setpal(int i, int r, int g, int b)
{
        xpal[i]=RGB565(r,g,b);
        //vga_setpalette(i, r>>2, g>>2, b>>2);
}

void vid_begin() {
}

void vid_end() {
        int x,y,c;
        for (y=0; y<240; y++) {
                char *p = &fb.ptr[y * 320];
                        for (x=0; x<320; x++) {
                                c = (p[x]);
                                vid->vram_s[y*320+x] = xpal[c];
			}
        }
}

void kb_init()
{
}

void kb_close()
{
}

void kb_poll()
{
        //keyboard_update();
}

void ev_poll()
{
        //kb_poll();
        //joy_poll();
}
